RealCP = {}
local RealCP = RealCP

RealCP.name = "RealCP"
RealCP.version = "1.2.3"

RealCP.showDebugMessages = false

-- Backups of the original functions
RealCP.OriginalGetLevelOrChampionPointsStringNoIcon = GetLevelOrChampionPointsStringNoIcon
RealCP.OriginalGetUnitEffectiveChampionPoints = GetUnitEffectiveChampionPoints

function RealCP.ToggleDebug()
	if RealCP.showDebugMessages then
		RealCP.showDebugMessages = false
		d("|caa0000[RealCP] Now hiding error messages and debug information.|r")
	else
		RealCP.showDebugMessages = true
		d("|c00aa00[RealCP] Now showing error messages and debug information.|r")
	end
end

function RealCP.Restore()
	GetLevelOrChampionPointsStringNoIcon = RealCP.OriginalGetLevelOrChampionPointsStringNoIcon
	GetUnitEffectiveChampionPoints = RealCP.OriginalGetUnitEffectiveChampionPoints
	
	d("|c00aa00[RealCP] Original function restored.|r")
end

function RealCP.Patch()
	-- Literally just patching esoui/ingame/globals/zo_championrankutils.lua:GetLevelOrChampionPointsStringNoIcon(level, championPoints)
	GetLevelOrChampionPointsStringNoIcon = function(level, championPoints)
		if championPoints and championPoints > 0 then
			return tostring(championPoints)
		elseif level and level > 0 then
			return tostring(level)
		else
			if RealCP.showDebugMessages then
				d("|caa0000[RealCP] Error resolving player level!|r")
			end
			return "|caa0000?|r"
		end
	end
	
	-- Replacing the Effective (= capped) version of the function with the uncapped
	GetUnitEffectiveChampionPoints = GetUnitChampionPoints
	
	if RealCP.showDebugMessages then
		d("[RealCP] Done patching.")
	end
end


function RealCP.Initialize()
	SLASH_COMMANDS['/realcpdebug'] = RealCP.ToggleDebug
	SLASH_COMMANDS['/realcprestore'] = RealCP.Restore
	SLASH_COMMANDS['/realcppatch'] = RealCP.Patch

	RealCP.Patch()
end

local function OnAddonLoaded(event, addonName)
    if addonName == RealCP.name then
        RealCP.Initialize()
	end
end

EVENT_MANAGER:RegisterForEvent(RealCP.name, EVENT_ADD_ON_LOADED, OnAddonLoaded)